#!/usr/bin/env python
#
# grib_checker.py checks Checks whatever you want to check in your life
#
# AUTHOR: BSC-CNS I. CERNICHARO
#

import os
import sys
import datetime

import grib_content

VERSION = "ALPHA 0.1"

def run(args):

    # Initiate the grib checks creating the grib_content object
    g_c = grib_content.grib_content(args)

    # Start adding messages to the log
    string = "#DATE AND TIME: "
    string += (24-len(string))*" "
    g_c.log += 80*"_" + "\n" + string + datetime.datetime.now().isoformat() + "\n#"
    string = "#GRIB_CCK VERSION: "
    string += (24-len(string))*" "
    g_c.log += "\n" + string + VERSION + "\n#"
    string = "FILENAME: "
    string += (24-len(string))*" " + g_c.pname
    g_c.log += "\n" + string + "\n" + g_c.print_num_keys() + "\n#"
    
    # Metada checks iteration
    metacck = g_c.check_meta_grid()
    for item in metacck:
        g_c.log += item + "\n#"
    
    # Data checks iteration
    datacck =  g_c.check_data_coords()
    for item in datacck:
        g_c.log += item

    g_c.log += "\n" + 80*"_"
    
    # Folder name where the file is storaged
    dir_name = "/".join(g_c.name.split('/')[:-1]) + "/"
    # Grib file name
    file_name = g_c.pname.replace('.grib','.txt')

    # Creating LOG file
    log_file_name =  dir_name + "LOG_Gribcck-" + file_name
    log_file = open(log_file_name, 'w')
    log_file.write(g_c.log)
    log_file.close()

    return g_c.log

if __name__ == "__main__":
    args = sys.argv[1:]

    for item in args:
        log = run(item)
        print log